require 'wise/label'
require 'wise/focus'

module Wise
  class Button < Label
    include Focus
    def initialize(parent, settings={}, &command)
      @command = (command) ? command : settings.delete(:command)
      super(parent, {:border=>2, :relief=>:up}.update(settings))
      bind("Button-Press") { |evt|
	if evt.window == self
	  self.relief = :down
	end
      }
      bind("Button-Release") { |evt|
	if evt.window == self
	  self.relief = :up
	  throw_event(FakeEvent.new(self, "Clicked"))
	end
      }
      bind("Clicked") { |evt|
	@command.call(evt)  if @command
	if defined? Menu
	  unless self.kind_of? MenuButton
	    ancestor = parent
	    while ancestor.kind_of? Menu
	      ancestor.unmap
	      ancestor = ancestor.parent
	      ancestor = ancestor.parent  if ancestor
	    end
	  end
	end
      }
      bind("Key") { |evt|
	if evt.window == self and (evt.key_string == " " or evt.key_sym == Return)
	  throw_event(FakeEvent.new(self, "Clicked"))
	end
      }
      bind("Enter") { self.bg_used = bg.light }
      bind("Leave") { self.bg_used = bg }
    end
    def command(&command)
      @command = command
    end
  end
end
