module Wise
  class SimpleDialog < VList
    def initialize(parent, settings={})
      #puts "SimpleDialog(#{parent}, #{settings})"
      super(parent, {:modal=>true, :title=>"Dialog", :map=>false}.update(settings))
      @text = Multi.new(self, :text=>settings[:text])
      hl = HList.new(self, :align=>:right)
      settings.each { |key, val|
	if val.kind_of? Proc
	  Button.new(hl, :text=>key, :command=>val)
	end
      }
      ok = Button.new(hl, :text=>"OK") { self.destroy() }
      bind("Key") { |evt|
	if evt.key_sym == Return or evt.key_sym == Escape
	  self.destroy()
	end
      }
      self.map()
    end
  end

  class InputDialog < Window
    def initialize(parent, settings={}, &ok_proc)
      super(parent, {:modal=>true, :title=>"Dialog", :map=>false}.update(settings))
      @text = Multi.new(self, :text=>settings[:text])
      @input = Input.new(self, :text=>settings[:input])
      hl = HList.new(self, :side=>:bottom)
      @ok = Button.new(hl, :text=>"OK") { ok_proc.call(); self.destroy() }
      @cancel = Button.new(hl, :text=>"Cancel") { self.destroy }
      self.map()
      @input.take_input_focus
      bind("Key") { |evt|
	if evt.key_sym == Return  # or Keypad_return
	  ok_proc.call()
	  self.destroy()
	elsif evt.key_sym == Escape
	  self.destroy()
	end
      }
    end

    def input
      @input.text
    end
  end
end
