module Wise
  class Event
    attr_reader :skip_parents, :skip_internals
    attr_accessor :name
    def release?
      not press?
    end
    def no_longer_original()
      @ascended = true
    end
    def original?
      not defined? @ascended
    end
    def no_parents!()
      @skip_parents = true
    end
    def no_internals!()
      @skip_internals = true
    end
  end

  class FakeEvent < Event
    @@serial = 0
    def initialize(window, name)
      @window = window
      @name = name
      @serial = @@serial
      @@serial += 1
    end
    attr_reader :window, :serial

    def x() 0 end
    def y() 0 end
    def width() @window.width end
    def height() @window.height end
  end

  class InputSetEvent < FakeEvent
    def initialize(window, data)
      super(window, "InputSet")
      @data = data
    end
    attr_reader :data
  end
end

