module Wise
  module Focus
    def Focus::advance_focus(candidate)
      begin
	toplevel = candidate.toplevel
	candidate = candidate.next_sibling()
	candidate = toplevel.first_sibling  if candidate == nil
	if candidate.kind_of? Focus
	  candidate.take_input_focus
	  # toplevel.focus_sibling = candidate
	  break
	end
      end while candidate != self
    end

    def initialize(parent, settings)
      super(parent, settings) # modules need no dup/update of settings
      bind("Key") { |evt|
	if evt.key_sym == Tab
	  #if evt.shift?
	  Focus::advance_focus(self)
	  #else
	  #  Focus::back_focus(self)
	  #end
	end
      }
    end

    def lost_input_focus
      self.relief = @backup_relief
# puts self
      @clean = false; clear; draw
    end

    def take_input_focus
      prev = toplevel.focus_sibling
      prev.lost_input_focus  if prev and prev != self
      toplevel.focus_sibling = self
      set_input_focus
      @backup_relief = self.relief  unless self == prev
      self.relief = :focus
    end
  end
end
