module Wise
  # Use this as :layout=> when you define your own methods;
  # otherwise (the default) Layout overrides your methods later.
  module NoLayout
  end

  module Layout
    def user_width()
      return 100  if @children.empty?
      w = @children.last.total_width
      (@children.length-2).downto(0) { |i|
	case @children[i].side
	when :left, :right
	  w += @children[i].total_width
	else
	  w = [w, @children[i].total_width].max
	end
      }
      w
    end

    def user_height()
      return 100  if @children.empty?
      h = @children.last.total_height
      (@children.length-2).downto(0) { |i|
	case @children[i].side
	when :left, :right
	  h = [h, @children[i].total_height].max
	else
	  h += @children[i].total_height
	end
      }
      h
    end

    def subpack(i, vx, vy, avw, avh)
      avw = 0  if avw < 0
      avh = 0  if avh < 0
      return 0, 0  if i >= @children.length
      w, h = nil, nil
      child = @children[i]
      child_width = [child.total_width, avw].min
      child_height = [child.total_height, avh].min
      case child.side
      when :left
	comp_x, comp_y = vx, vy
	w, h = subpack(i+1, vx+child_width, vy, avw-child_width, avh)
	# w, h = w+(avw < child_width ? avw : child_width), [h, child_height, avh].max
	w, h = avw, avh
	comp_width, comp_height = child_width, h
      when :right
	w, h = subpack(i+1, vx, vy, avw-child_width, avh)
	comp_x, comp_y = vx+w, vy
	# w, h = w+child_width, [h, child_height, avh].max
	w, h = avw, avh
	comp_width, comp_height = child_width, h
      when :bottom
	w, h = subpack(i+1, vx, vy, avw, avh-child_height)
	comp_x, comp_y = vx, vy+h
	# w, h = [w, child_width, avw].max, h+child_height
	comp_width, comp_height = avw, child_height
	w, h = avw, avh
      else  # mostly :top
	comp_x, comp_y = vx, vy
	w, h = subpack(i+1, vx, vy+child_height, avw, avh-child_height)
	# w, h = [w, child_width, avw].max, h+(avh < child_height ? avh : child_height)
	comp_width, comp_height = avw, child_height
	w, h = avw, avh
      end
      child.move(comp_x, comp_y)
      if i == @children.length-1
	child.pack(avw, avh)
	return avw, avh
      else
	child.pack(comp_width, comp_height)
	return w, h
      end
    end

    def pack(w, h)
      resize(w, h)  unless toplevel?
      subpack(0, 0, 0, w, h)
    end
  end
end
