module Wise
  module SubLayout
    # Not tested...
    #def insert(pos)
    #  @children.insert(pos, child)
    #  pack()  if mapped?  # should be stuff that's in add_child as well
    #end
  end

  module VLayout
    #include SubLayout

    def user_width
      (@children.map { |c| c.total_width } << 0).max
    end

    def user_height
      result = 0
      @children.each { |c| result += c.total_height }
      result
    end

    def pack(w, h)
      resize(w, h)  unless toplevel?
      hsum = border
      @children.each_with_index { |c, i|
	double_border = 2 * border
	th = c.total_height
	c.pack(w-double_border, th)
        c.move(border, hsum)
        hsum += th
      }
    end
  end

  module HLayout
    #include SubLayout

    def user_width
      result = 0
      @children.each { |c| result += c.total_width }
      return result
    end

    def user_height
      (@children.map { |c| c.total_height } << 0).max
    end

    def pack(w, h)
      resize(w, h)  unless toplevel?
      wsum = border
      @children.each_with_index { |c, i|
	double_border = 2 * border
	tw = c.total_width
	c.pack(tw, h-double_border)
        c.move(wsum, border)
        wsum += tw
      }
    end
  end

  class VList < Window
    def initialize(parent, settings={})
      super(parent, {:layout=>VLayout}.update(settings))
      bind("Button-Press") { |evt|
	index = -1
	h_sum = border
	while index < @children.length-1 and evt.y >= h_sum
	  index += 1
	  h_sum += @children[index].height
	end
      }
    end
  end

  class HList < Window
    def initialize(parent, settings={})
      super(parent, {:layout=>HLayout}.update(settings))
    end
  end
end
