require 'wise/label'

module Wise
  # Need to think about :align => :left
  # :top won't work nicely, unless I use :halign and :valign
  # another option is :align => "tl" for top-left, etc.
  class Multi < Label
    def initialize(parent, settings={})
      @text = settings.delete(:text)
      @text = ""  unless @text
      @old_text = @text.split("\n")  # complete copy...
      @text = @text.split("\n")
      super(parent, {:align=>:left, :text=>@text}.update(settings))
    end

    def draw_selection(si, ei)
      clear; draw
      line = @text[si[0]] || ""
      if si[0] == ei[0]
	draw_string(line[si[1]..ei[1]],
		    hoffset(font.width(line)) + font.width(line[0...si[1]]),
		    @yoffset + font.ascent + si[0]*font.height,
		    :invert)
      else
	draw_string(line[si[1]..-1],
		    hoffset(font.width(line)) + font.width(line[0...si[1]]),
		    @yoffset + font.ascent + si[0]*font.height,
		    :invert)
	(si[0]+1).upto(ei[0]-1) { |index|
	  line = @text[index] || ""
	  draw_string(line,
		      hoffset(font.width(line)), @yoffset + font.ascent + index*font.height, :invert)
	}
	line = @text[ei[0]] || ""
	draw_string(line[0...ei[1]],
		    hoffset(font.width(line)), @yoffset + font.ascent + ei[0]*font.height, :invert)
      end
    end

    def grab_selection()
      selection = @text[@start_index[0]..@end_index[0]].map { |line| line.dup }
      selection[-1][@end_index[1]+1..-1] = ''
      selection[0][0...@start_index[1]] = ''
      selection.join "\n"
    end

    def get_index(bx, by)
      index = (by-@yoffset) / font.height()
      return index, super(bx, by, @text[index] || "")
    end

    def text()
      @text.join "\n"
    end

    def text=(new_text)
      new_text = ""  unless new_text
      @text = new_text.split("\n")
      @clean = false
      self.layout_dirty!
      clear; draw; display.flush
      new_text
    end

    def draw_content(xoffset, yoffset)
      @yoffset = yoffset
      @text.each_with_index { |line,i|
	draw_string(line, hoffset(font.width(line)),
		    yoffset + font.ascent + i*font.height)
      }
      draw_content_Window(xoffset, yoffset)
    end

    def user_width()
      (@text.map {|line|
	font.width(line)
      } << 0).max
    end

    def user_height()
      @text.length * font.height()
    end
  end
end
