require 'wise/label'  # rather, border...

# snippet from window.rb that didn't belong there...
if false
      if @settings[:vscroll]
	@scroll_dist = {
	  "LineUp"=>-0.1, "LineDown"=>0.1, "PageUp"=>-0.25, "PageDown"=>0.25
	}
	@vscroll = @settings.delete(:vscroll)
	@vscroll.bind("Scroll") { |evt|
	  detail = evt.name.split(/-/)[1]
	  p detail
	  p @scroll_dist[detail]
	  @vscroll.scroll(@scroll_dist[detail])
	}
      end
end

module Wise
  class Scrollbar < Window
    def initialize(parent, settings={})
      @range = [0.0, 1.0]
      @view = [0.0, 0.5]
      super(parent, {:border=>1}.update(settings).update(:relief=>:down))
      bind("Button-Press") { |evt|
	if evt.y <= @arrow_h
	  throw_event(FakeEvent.new(self, "Scroll-LineUp"))
	elsif evt.y < height-@arrow_h-1
	  for_view = coord_view()
	  if evt.y < for_view[0]
	    throw_event(FakeEvent.new(self, "Scroll-PageUp"))
	  elsif evt.y <= for_view[1]
	    @start_drag = evt.y
	    @start_view = @view.dup
	  else
	    throw_event(FakeEvent.new(self, "Scroll-PageDown"))
	  end
	else
	  throw_event(FakeEvent.new(self, "Scroll-LineDown"))
	end
      }
      bind("Motion") { |evt|
	if @start_drag
	  factor = coord_range.to_f / (@range[1]-@range[0])
	  @view = @start_view.collect { |num| num + (evt.y-@start_drag)/factor }
	  if @view[1] > @range[1]
	    diff = @view[1] - @range[1]
	    @view.collect! { |num| num -= diff }
	  end
	  if @view[0] < @range[0]
	    diff = @range[0] - @view[0]
	    @view.collect! { |num| num += diff }
	  end
	  clear; draw
	end
      }
      bind("Button-Release") {
	@start_drag = nil
      }
    end

    def safeguard()
      if @view[1] > @range[1]
	@view[0] -= @view[1] - @range[1]
	@view[1] = @range[1]
      end
      if @view[0] < @range[0]
	@view[1] += @range[0] - @view[0]
	@view[0] = @range[0]
      end
      if @view[1] > @range[1]
	@view = @range.dup()
      end
      p @view
      p @range
      clear; draw()
    end

    def partially(visible, total)
      @view = [@view[0], @view[0] + visible/total]
      safeguard()
    end

    def scroll(amount)
      @view.collect! { |num| num += amount }
      safeguard()
    end

    attr_reader :view

    def coord_range()  height - 2 * (@arrow_h+2)  end
    def coord_view()
      for_range = height - 2 * (@arrow_h+2) - 1
      for_view = @view.collect { |num|
	factor = num.to_f-@range[0] / @range[1]-@range[0]
	factor * for_range + @arrow_h + 2
      }
    end

    def draw_content(ignore, too)  # no offsets here
      @arrow_h = [height / 4, width].min
      for_view = coord_view()
      self.fg_used = bg.dark
      draw_line(width-3, height-@arrow_h-1, (width-1)/2, height-3)
      draw_line(2, @arrow_h, width-3, @arrow_h)
      draw_line(width/2, 2, width-3, @arrow_h)
      draw_line(3, for_view[1], width-3, for_view[1])
      draw_line(width-3, for_view[0], width-3, for_view[1])
      self.fg_used = bg.light
      draw_line(2, @arrow_h, (width-1)/2, 2)
      draw_line(2, height-@arrow_h-1, width-3, height-@arrow_h-1)
      draw_line(width/2, height-1, 2, height-@arrow_h-3)
      draw_line(3, for_view[0], width-3, for_view[0])
      draw_line(3, for_view[0], 3, for_view[1])
      self.fg_used = fg
      # even though we don't expect modal windows, let's be consistent:
      super(ignore, too)
    end

    def user_width() 11  end
    def user_height() 120 end
  end

# NEW ...
  class Scroll < Window
    def initialize(parent, settings={})
      super(parent, {:layout=>NoLayout}.update(settings))
      @vbar = Scrollbar.new(self)
      @vbar.bind("Scroll") { |evt|
        @children[0].move(@children[0].x, 0)
      }
      @hbar = Scrollbar.new(self)
      @hbar.bind("Scroll") { |evt|
        # evt.interval
        @children[0].move(0, @children[0].y)
      }
    end

    def add(child)
      puts("Replacing child in #{self}")  if children[0]
      children[0] = child
    end

    def pack(w, h)
puts "Scrollbar#pack(#{w}, #{h})"
      resize(w, h)  unless toplevel?
      @vbar.move(w-8, 0)
      @vbar.pack(8, h-8)
      @hbar.move(0, h-8)
      @hbar.pack(w-8, 8)
      if @children[0]
        c = @children[0]
        @c_w, @c_h = c.total_width(), c.total_height()
        c.move(0, 0)
        c.pack(@c_w, @c_h)
      end
    end
  end
end
