require 'wise'
#require 'wise/list'
#require 'wise/event'

module Wise
  class SelectEvent < FakeEvent
    def initialize(window, name, value, index)
      super(window, name)
      @value = value
      @index = index
    end
    attr_reader :value, :index
  end

  class Select < Button
    def initialize(parent, settings={})
      @values = settings.delete(:values) || []
      @values << ""  if @values.length == 0
      index = settings.delete(:index) || 0
      @value = settings.delete(:value) || @values[index]
      super(parent, {:text=>@value, :border=>2}.update(settings)) {
	unless @input
	  @input = VList.new(nil, :override=>true, :map=>false)
	  @input.extend Popup
	  @values.each_with_index { |v, i|
	    Button.new(@input, :border=>0, :text=>v) {
	      self.text = v
	      @input.unmap
	      self.throw_event(SelectEvent.new(self, "Select", v, i))
	    }
	  }
	end
	# WHERE to popup exactly? resembles Menu toubles, extract common stuff
	@input.popup(root_x, root_y+height)
      }
    end
    def index=(new_index)
      new_index = 0  if new_index < 0
      new_index = @values.length-1  if new_index >= @values.length
      self.text = @values[new_index]
    end
    def user_width()
      @values.collect { |v|
        font.width(v)
      }.max
    end
    def pack(w, h)
      resize(w, h)  unless toplevel?
    end
    def destroy()
      super()
      @input.destroy()  if @input
    end
  end

  if __FILE__ == $0
    w = Window.new(nil)
    Select.new(w, :values=>["hello", "world"])
    main_thread()
  end
end
